<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Input StructType
 * @subpackage Structs
 */
class Input extends AbstractStructBase
{
    /**
     * The kullanici
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $kullanici;
    /**
     * The sifre
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $sifre;
    /**
     * Constructor method for Input
     * @uses Input::setKullanici()
     * @uses Input::setSifre()
     * @param string $kullanici
     * @param string $sifre
     */
    public function __construct($kullanici = null, $sifre = null)
    {
        $this
            ->setKullanici($kullanici)
            ->setSifre($sifre);
    }
    /**
     * Get kullanici value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getKullanici()
    {
        return isset($this->kullanici) ? $this->kullanici : null;
    }
    /**
     * Set kullanici value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $kullanici
     * @return \StructType\Input
     */
    public function setKullanici($kullanici = null)
    {
        // validation for constraint: string
        if (!is_null($kullanici) && !is_string($kullanici)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kullanici, true), gettype($kullanici)), __LINE__);
        }
        if (is_null($kullanici) || (is_array($kullanici) && empty($kullanici))) {
            unset($this->kullanici);
        } else {
            $this->kullanici = $kullanici;
        }
        return $this;
    }
    /**
     * Get sifre value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSifre()
    {
        return isset($this->sifre) ? $this->sifre : null;
    }
    /**
     * Set sifre value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sifre
     * @return \StructType\Input
     */
    public function setSifre($sifre = null)
    {
        // validation for constraint: string
        if (!is_null($sifre) && !is_string($sifre)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sifre, true), gettype($sifre)), __LINE__);
        }
        if (is_null($sifre) || (is_array($sifre) && empty($sifre))) {
            unset($this->sifre);
        } else {
            $this->sifre = $sifre;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Input
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
