<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InputUlkeGrup StructType
 * @subpackage Structs
 */
class InputUlkeGrup extends AbstractStructBase
{
    /**
     * The apg
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $apg;
    /**
     * The fax
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $fax;
    /**
     * The koli
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $koli;
    /**
     * The kullanici
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $kullanici;
    /**
     * The sifre
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $sifre;
    /**
     * The taahhut
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $taahhut;
    /**
     * The turpex
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $turpex;
    /**
     * Constructor method for InputUlkeGrup
     * @uses InputUlkeGrup::setApg()
     * @uses InputUlkeGrup::setFax()
     * @uses InputUlkeGrup::setKoli()
     * @uses InputUlkeGrup::setKullanici()
     * @uses InputUlkeGrup::setSifre()
     * @uses InputUlkeGrup::setTaahhut()
     * @uses InputUlkeGrup::setTurpex()
     * @param int $apg
     * @param int $fax
     * @param int $koli
     * @param string $kullanici
     * @param string $sifre
     * @param int $taahhut
     * @param int $turpex
     */
    public function __construct($apg = null, $fax = null, $koli = null, $kullanici = null, $sifre = null, $taahhut = null, $turpex = null)
    {
        $this
            ->setApg($apg)
            ->setFax($fax)
            ->setKoli($koli)
            ->setKullanici($kullanici)
            ->setSifre($sifre)
            ->setTaahhut($taahhut)
            ->setTurpex($turpex);
    }
    /**
     * Get apg value
     * @return int|null
     */
    public function getApg()
    {
        return $this->apg;
    }
    /**
     * Set apg value
     * @param int $apg
     * @return \StructType\InputUlkeGrup
     */
    public function setApg($apg = null)
    {
        // validation for constraint: int
        if (!is_null($apg) && !(is_int($apg) || ctype_digit($apg))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($apg, true), gettype($apg)), __LINE__);
        }
        $this->apg = $apg;
        return $this;
    }
    /**
     * Get fax value
     * @return int|null
     */
    public function getFax()
    {
        return $this->fax;
    }
    /**
     * Set fax value
     * @param int $fax
     * @return \StructType\InputUlkeGrup
     */
    public function setFax($fax = null)
    {
        // validation for constraint: int
        if (!is_null($fax) && !(is_int($fax) || ctype_digit($fax))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($fax, true), gettype($fax)), __LINE__);
        }
        $this->fax = $fax;
        return $this;
    }
    /**
     * Get koli value
     * @return int|null
     */
    public function getKoli()
    {
        return $this->koli;
    }
    /**
     * Set koli value
     * @param int $koli
     * @return \StructType\InputUlkeGrup
     */
    public function setKoli($koli = null)
    {
        // validation for constraint: int
        if (!is_null($koli) && !(is_int($koli) || ctype_digit($koli))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($koli, true), gettype($koli)), __LINE__);
        }
        $this->koli = $koli;
        return $this;
    }
    /**
     * Get kullanici value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getKullanici()
    {
        return isset($this->kullanici) ? $this->kullanici : null;
    }
    /**
     * Set kullanici value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $kullanici
     * @return \StructType\InputUlkeGrup
     */
    public function setKullanici($kullanici = null)
    {
        // validation for constraint: string
        if (!is_null($kullanici) && !is_string($kullanici)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kullanici, true), gettype($kullanici)), __LINE__);
        }
        if (is_null($kullanici) || (is_array($kullanici) && empty($kullanici))) {
            unset($this->kullanici);
        } else {
            $this->kullanici = $kullanici;
        }
        return $this;
    }
    /**
     * Get sifre value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSifre()
    {
        return isset($this->sifre) ? $this->sifre : null;
    }
    /**
     * Set sifre value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sifre
     * @return \StructType\InputUlkeGrup
     */
    public function setSifre($sifre = null)
    {
        // validation for constraint: string
        if (!is_null($sifre) && !is_string($sifre)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sifre, true), gettype($sifre)), __LINE__);
        }
        if (is_null($sifre) || (is_array($sifre) && empty($sifre))) {
            unset($this->sifre);
        } else {
            $this->sifre = $sifre;
        }
        return $this;
    }
    /**
     * Get taahhut value
     * @return int|null
     */
    public function getTaahhut()
    {
        return $this->taahhut;
    }
    /**
     * Set taahhut value
     * @param int $taahhut
     * @return \StructType\InputUlkeGrup
     */
    public function setTaahhut($taahhut = null)
    {
        // validation for constraint: int
        if (!is_null($taahhut) && !(is_int($taahhut) || ctype_digit($taahhut))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($taahhut, true), gettype($taahhut)), __LINE__);
        }
        $this->taahhut = $taahhut;
        return $this;
    }
    /**
     * Get turpex value
     * @return int|null
     */
    public function getTurpex()
    {
        return $this->turpex;
    }
    /**
     * Set turpex value
     * @param int $turpex
     * @return \StructType\InputUlkeGrup
     */
    public function setTurpex($turpex = null)
    {
        // validation for constraint: int
        if (!is_null($turpex) && !(is_int($turpex) || ctype_digit($turpex))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($turpex, true), gettype($turpex)), __LINE__);
        }
        $this->turpex = $turpex;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\InputUlkeGrup
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
