<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Output StructType
 * @subpackage Structs
 */
class Output extends AbstractStructBase
{
    /**
     * The dongu
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OutputDongu[]
     */
    public $dongu;
    /**
     * The sonucAciklama
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $sonucAciklama;
    /**
     * The sonucKodu
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $sonucKodu;
    /**
     * Constructor method for Output
     * @uses Output::setDongu()
     * @uses Output::setSonucAciklama()
     * @uses Output::setSonucKodu()
     * @param \StructType\OutputDongu[] $dongu
     * @param string $sonucAciklama
     * @param int $sonucKodu
     */
    public function __construct(array $dongu = array(), $sonucAciklama = null, $sonucKodu = null)
    {
        $this
            ->setDongu($dongu)
            ->setSonucAciklama($sonucAciklama)
            ->setSonucKodu($sonucKodu);
    }
    /**
     * Get dongu value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OutputDongu[]|null
     */
    public function getDongu()
    {
        return isset($this->dongu) ? $this->dongu : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDongu method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDongu method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDonguForArrayConstraintsFromSetDongu(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $outputDonguItem) {
            // validation for constraint: itemType
            if (!$outputDonguItem instanceof \StructType\OutputDongu) {
                $invalidValues[] = is_object($outputDonguItem) ? get_class($outputDonguItem) : sprintf('%s(%s)', gettype($outputDonguItem), var_export($outputDonguItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The dongu property can only contain items of type \StructType\OutputDongu, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set dongu value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OutputDongu[] $dongu
     * @return \StructType\Output
     */
    public function setDongu(array $dongu = array())
    {
        // validation for constraint: array
        if ('' !== ($donguArrayErrorMessage = self::validateDonguForArrayConstraintsFromSetDongu($dongu))) {
            throw new \InvalidArgumentException($donguArrayErrorMessage, __LINE__);
        }
        if (is_null($dongu) || (is_array($dongu) && empty($dongu))) {
            unset($this->dongu);
        } else {
            $this->dongu = $dongu;
        }
        return $this;
    }
    /**
     * Add item to dongu value
     * @throws \InvalidArgumentException
     * @param \StructType\OutputDongu $item
     * @return \StructType\Output
     */
    public function addToDongu(\StructType\OutputDongu $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OutputDongu) {
            throw new \InvalidArgumentException(sprintf('The dongu property can only contain items of type \StructType\OutputDongu, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->dongu[] = $item;
        return $this;
    }
    /**
     * Get sonucAciklama value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSonucAciklama()
    {
        return isset($this->sonucAciklama) ? $this->sonucAciklama : null;
    }
    /**
     * Set sonucAciklama value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sonucAciklama
     * @return \StructType\Output
     */
    public function setSonucAciklama($sonucAciklama = null)
    {
        // validation for constraint: string
        if (!is_null($sonucAciklama) && !is_string($sonucAciklama)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sonucAciklama, true), gettype($sonucAciklama)), __LINE__);
        }
        if (is_null($sonucAciklama) || (is_array($sonucAciklama) && empty($sonucAciklama))) {
            unset($this->sonucAciklama);
        } else {
            $this->sonucAciklama = $sonucAciklama;
        }
        return $this;
    }
    /**
     * Get sonucKodu value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getSonucKodu()
    {
        return isset($this->sonucKodu) ? $this->sonucKodu : null;
    }
    /**
     * Set sonucKodu value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $sonucKodu
     * @return \StructType\Output
     */
    public function setSonucKodu($sonucKodu = null)
    {
        // validation for constraint: int
        if (!is_null($sonucKodu) && !(is_int($sonucKodu) || ctype_digit($sonucKodu))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sonucKodu, true), gettype($sonucKodu)), __LINE__);
        }
        if (is_null($sonucKodu) || (is_array($sonucKodu) && empty($sonucKodu))) {
            unset($this->sonucKodu);
        } else {
            $this->sonucKodu = $sonucKodu;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Output
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
