<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OutputUcret StructType
 * @subpackage Structs
 */
class OutputUcret extends AbstractStructBase
{
    /**
     * The sonucAciklama
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $sonucAciklama;
    /**
     * The sonucKodu
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $sonucKodu;
    /**
     * The ucret
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ucret;
    /**
     * Constructor method for OutputUcret
     * @uses OutputUcret::setSonucAciklama()
     * @uses OutputUcret::setSonucKodu()
     * @uses OutputUcret::setUcret()
     * @param string $sonucAciklama
     * @param int $sonucKodu
     * @param string $ucret
     */
    public function __construct($sonucAciklama = null, $sonucKodu = null, $ucret = null)
    {
        $this
            ->setSonucAciklama($sonucAciklama)
            ->setSonucKodu($sonucKodu)
            ->setUcret($ucret);
    }
    /**
     * Get sonucAciklama value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSonucAciklama()
    {
        return isset($this->sonucAciklama) ? $this->sonucAciklama : null;
    }
    /**
     * Set sonucAciklama value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sonucAciklama
     * @return \StructType\OutputUcret
     */
    public function setSonucAciklama($sonucAciklama = null)
    {
        // validation for constraint: string
        if (!is_null($sonucAciklama) && !is_string($sonucAciklama)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sonucAciklama, true), gettype($sonucAciklama)), __LINE__);
        }
        if (is_null($sonucAciklama) || (is_array($sonucAciklama) && empty($sonucAciklama))) {
            unset($this->sonucAciklama);
        } else {
            $this->sonucAciklama = $sonucAciklama;
        }
        return $this;
    }
    /**
     * Get sonucKodu value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getSonucKodu()
    {
        return isset($this->sonucKodu) ? $this->sonucKodu : null;
    }
    /**
     * Set sonucKodu value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $sonucKodu
     * @return \StructType\OutputUcret
     */
    public function setSonucKodu($sonucKodu = null)
    {
        // validation for constraint: int
        if (!is_null($sonucKodu) && !(is_int($sonucKodu) || ctype_digit($sonucKodu))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sonucKodu, true), gettype($sonucKodu)), __LINE__);
        }
        if (is_null($sonucKodu) || (is_array($sonucKodu) && empty($sonucKodu))) {
            unset($this->sonucKodu);
        } else {
            $this->sonucKodu = $sonucKodu;
        }
        return $this;
    }
    /**
     * Get ucret value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUcret()
    {
        return isset($this->ucret) ? $this->ucret : null;
    }
    /**
     * Set ucret value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $ucret
     * @return \StructType\OutputUcret
     */
    public function setUcret($ucret = null)
    {
        // validation for constraint: string
        if (!is_null($ucret) && !is_string($ucret)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ucret, true), gettype($ucret)), __LINE__);
        }
        if (is_null($ucret) || (is_array($ucret) && empty($ucret))) {
            unset($this->ucret);
        } else {
            $this->ucret = $ucret;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OutputUcret
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
