<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OutputUlkeTum StructType
 * @subpackage Structs
 */
class OutputUlkeTum extends AbstractStructBase
{
    /**
     * The donguList
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OutputUlke[]
     */
    public $donguList;
    /**
     * The sonucAciklama
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $sonucAciklama;
    /**
     * The sonucKodu
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $sonucKodu;
    /**
     * The state
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $state;
    /**
     * Constructor method for OutputUlkeTum
     * @uses OutputUlkeTum::setDonguList()
     * @uses OutputUlkeTum::setSonucAciklama()
     * @uses OutputUlkeTum::setSonucKodu()
     * @uses OutputUlkeTum::setState()
     * @param \StructType\OutputUlke[] $donguList
     * @param string $sonucAciklama
     * @param int $sonucKodu
     * @param bool $state
     */
    public function __construct(array $donguList = array(), $sonucAciklama = null, $sonucKodu = null, $state = null)
    {
        $this
            ->setDonguList($donguList)
            ->setSonucAciklama($sonucAciklama)
            ->setSonucKodu($sonucKodu)
            ->setState($state);
    }
    /**
     * Get donguList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OutputUlke[]|null
     */
    public function getDonguList()
    {
        return isset($this->donguList) ? $this->donguList : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDonguList method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDonguList method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDonguListForArrayConstraintsFromSetDonguList(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $outputUlkeTumDonguListItem) {
            // validation for constraint: itemType
            if (!$outputUlkeTumDonguListItem instanceof \StructType\OutputUlke) {
                $invalidValues[] = is_object($outputUlkeTumDonguListItem) ? get_class($outputUlkeTumDonguListItem) : sprintf('%s(%s)', gettype($outputUlkeTumDonguListItem), var_export($outputUlkeTumDonguListItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The donguList property can only contain items of type \StructType\OutputUlke, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set donguList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OutputUlke[] $donguList
     * @return \StructType\OutputUlkeTum
     */
    public function setDonguList(array $donguList = array())
    {
        // validation for constraint: array
        if ('' !== ($donguListArrayErrorMessage = self::validateDonguListForArrayConstraintsFromSetDonguList($donguList))) {
            throw new \InvalidArgumentException($donguListArrayErrorMessage, __LINE__);
        }
        if (is_null($donguList) || (is_array($donguList) && empty($donguList))) {
            unset($this->donguList);
        } else {
            $this->donguList = $donguList;
        }
        return $this;
    }
    /**
     * Add item to donguList value
     * @throws \InvalidArgumentException
     * @param \StructType\OutputUlke $item
     * @return \StructType\OutputUlkeTum
     */
    public function addToDonguList(\StructType\OutputUlke $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OutputUlke) {
            throw new \InvalidArgumentException(sprintf('The donguList property can only contain items of type \StructType\OutputUlke, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->donguList[] = $item;
        return $this;
    }
    /**
     * Get sonucAciklama value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSonucAciklama()
    {
        return isset($this->sonucAciklama) ? $this->sonucAciklama : null;
    }
    /**
     * Set sonucAciklama value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sonucAciklama
     * @return \StructType\OutputUlkeTum
     */
    public function setSonucAciklama($sonucAciklama = null)
    {
        // validation for constraint: string
        if (!is_null($sonucAciklama) && !is_string($sonucAciklama)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sonucAciklama, true), gettype($sonucAciklama)), __LINE__);
        }
        if (is_null($sonucAciklama) || (is_array($sonucAciklama) && empty($sonucAciklama))) {
            unset($this->sonucAciklama);
        } else {
            $this->sonucAciklama = $sonucAciklama;
        }
        return $this;
    }
    /**
     * Get sonucKodu value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getSonucKodu()
    {
        return isset($this->sonucKodu) ? $this->sonucKodu : null;
    }
    /**
     * Set sonucKodu value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $sonucKodu
     * @return \StructType\OutputUlkeTum
     */
    public function setSonucKodu($sonucKodu = null)
    {
        // validation for constraint: int
        if (!is_null($sonucKodu) && !(is_int($sonucKodu) || ctype_digit($sonucKodu))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sonucKodu, true), gettype($sonucKodu)), __LINE__);
        }
        if (is_null($sonucKodu) || (is_array($sonucKodu) && empty($sonucKodu))) {
            unset($this->sonucKodu);
        } else {
            $this->sonucKodu = $sonucKodu;
        }
        return $this;
    }
    /**
     * Get state value
     * @return bool|null
     */
    public function getState()
    {
        return $this->state;
    }
    /**
     * Set state value
     * @param bool $state
     * @return \StructType\OutputUlkeTum
     */
    public function setState($state = null)
    {
        // validation for constraint: boolean
        if (!is_null($state) && !is_bool($state)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($state, true), gettype($state)), __LINE__);
        }
        $this->state = $state;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OutputUlkeTum
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
